#define _CRT_SECURE_NO_WARNINGS
#define _SILENCE_CXX17_C_HEADER_DEPRECATION_WARNING
#include <bits/stdc++.h>
using namespace std;
#define CRP(t, x) const t &x
#define OPL(t, x) bool operator<(CRP(t, x)) const
#define FIL(x, v) memset(x, v, sizeof(x))
#define CLR(x) FIL(x, 0)
#define NE1(x) FIL(x, -1)
#define INF(x) FIL(x, 0x3f)
#ifndef _DEBUG
#define _DEBUG 0
#endif // !_DEBUG
#define IFD if (_DEBUG)
typedef long long ll, i64;
const int N = 2e5 + 50;
int a1[N], a2[N];
int main()
{
    string s, t;
    cin >> s >> t;
    a1[0] = -1, a2[t.size()] = s.size();
    for (int i = 0; i < t.size(); i++)
        a1[i + 1] = s.find(t[i], a1[i] + 1);
    for (int i = t.size() - 1; i >= 0; i--)
        a2[i + 1] = s.rfind(t[i], a2[i + 2] - 1);
    int ans = max<int>(s.size() - a1[t.size()] - 1, a2[1]);
    for (int i = 2; i <= t.size(); i++) ans = max(ans, max(a1[i] - a1[i - 1], a2[i] - a2[i - 1]) - 1);
    for (int i = 1; i <= t.size(); i++) ans = max(ans, a2[i] - a1[i]);
    for (int i = 2; i <= t.size(); i++) ans = max(ans, a2[i] - a1[i - 1] - 1);
    cout << ans;
    return 0;
}